// ===========================================================================
// OpenORB Examples
//
// (c) 2000, Exolab.org
// ===========================================================================

package poa.defaultServant;

import java.io.*;

public class FileSystem extends IFileSystemPOA
{

	protected static java.util.Vector _liste;

	private org.omg.PortableServer.POA _poa;

	public FileSystem( org.omg.PortableServer.POA poa )
	{
		_poa = poa;
		_liste = new java.util.Vector();

		try
		{
			poa.set_servant ( new FileDescriptor(poa) );
		}
		catch ( org.omg.PortableServer.POAPackage.WrongPolicy ex )
		{
			System.out.println("Unable to set default servant because");
			System.out.println("this POA does not have the good policies");
			System.exit(0);			
		}
	}

	public IFileDescriptor open(java.lang.String file_name, int flags)
	{
		DataInputStream file;
		org.omg.CORBA.Object obj;
		
		try
		{
			file = new DataInputStream(
			           new BufferedInputStream(
						   new FileInputStream(file_name)));
		}
		catch ( java.io.IOException ex )
		{
			System.out.println("Unable to open file : "+file_name);
			return null;
		}
		
		_liste.addElement ( file );

		byte [] oid = (new String( new Integer(_liste.size()).toString() )).getBytes();				

		try
		{	
			obj = _poa.create_reference_with_id(oid,"IDL:IFileDescriptor:1.0");
		}
		catch ( org.omg.PortableServer.POAPackage.WrongPolicy ex )
		{
			System.out.println("Unable to create the reference because the POA");
			System.out.println("does not have the good policies");

			return null;
		}

		return IFileDescriptorHelper.narrow( obj );
	}
}
