/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The name "Exolab" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of Intalio Inc.  For written permission, please
 *    contact info@exolab.org.
 *
 * 4. Products derived from this Software may not be called "Exolab"
 *    nor may "Exolab" appear in their names without prior written
 *    permission of Intalio Inc. Exolab is a registered trademark of
 *    Intalio Inc.
 *
 * 5. Due credit should be given to the Exolab Project
 *    (http://www.exolab.org/).
 *
 * THIS SOFTWARE IS PROVIDED BY INTALIO AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL INTALIO OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2000 (C) Intalio Inc. All Rights Reserved.
 *
 * $Id: BenchmarkImpl.java,v 1.2 2001/02/16 21:08:59 omodica Exp $
 *
 * Date         Author  Changes
 */

package org.openorb.bench;

import org.openorb.test.iiop.value.*;

/**
 *
 * @author  <a href="mailto:wood@intalio.com">Chris Wood &lt;wood@intalio.com&gt;</a>
 * @version $Revision: 1.2 $ $Date: 2001/02/16 21:08:59 $
 */
public class BenchmarkImpl implements org.openorb.bench.BenchmarkOperations {
	public BenchmarkImpl(org.omg.CORBA.ORB orb, org.omg.PortableServer.POA poa) {
		_orb = orb;
		_poa = poa;
	}
	
	private org.omg.CORBA.ORB _orb;
	private org.omg.PortableServer.POA _poa;

	private static final int F_L = 9234987;
	
	public void ping() {}

	public void raise_exception() {
		throw new org.omg.CORBA.UNKNOWN();
	}

	public org.omg.CORBA.Object echo_Object(org.omg.CORBA.Object arg) {
		return arg;
	}

	public org.omg.CORBA.TypeCode echo_TypeCode(org.omg.CORBA.TypeCode arg) {
		return arg;
	}

	public org.omg.CORBA.Any echo_any(org.omg.CORBA.Any arg) {
		return arg;
	}

	public org.omg.CORBA.Any[] echo_any_s(org.omg.CORBA.Any[] arg) {
		return arg;
	}

	public boolean echo_boolean(boolean arg) {
		return arg;
	}

	public boolean[] echo_boolean_s(boolean[] arg) {
		return arg;
	}

	public char echo_char(char arg) {
		return arg;
	}

	public char[] echo_char_s(char[] arg) {
		return arg;
	}

	public double echo_double(double arg) {
		return arg;
	}

	public double[] echo_double_s(double[] arg) {
		return arg;
	}

	public float echo_float(float arg) {
		return arg;
	}

	public float[] echo_float_s(float[] arg) {
		return arg;
	}

	public int echo_long(int arg) {
		return arg;
	}

	public int[] echo_long_s(int[] arg) {
		return arg;
	}

	public int[][] echo_long_s_s(int[][] arg) {
		return arg;
	}

	public long echo_longlong(long arg) {
		return arg;
	}

	public long[] echo_longlong_s(long[] arg) {
		return arg;
	}

	public byte echo_octet(byte arg) {
		return arg;
	}

	public byte[] echo_octet_s(byte[] arg) {
		return arg;
	}
	
	public byte[][] echo_octet_s_s(byte[][] arg) {
		return arg;
	}

	public short echo_short(short arg) {
		return arg;
	}

	public short[] echo_short_s(short[] arg) {
		return arg;
	}

	public java.lang.String echo_string(java.lang.String arg) {
		return arg;
	}

	public java.lang.String[] echo_string_s(java.lang.String[] arg) {
		return arg;
	}

	public int echo_ulong(int arg) {
		return arg;
	}

	public int[] echo_ulong_s(int[] arg) {
		return arg;
	}

	public long echo_ulonglong(long arg) {
		return arg;
	}

	public long[] echo_ulonglong_s(long[] arg) {
		return arg;
	}

	public short echo_ushort(short arg) {
		return arg;
	}

	public short[] echo_ushort_s(short[] arg) {
		return arg;
	}

	public char echo_wchar(char arg) {
		return arg;
	}

	public char[] echo_wchar_s(char[] arg) {
		return arg;
	}

	public java.lang.String echo_wstring(java.lang.String arg) {
		return arg;
	}

	public java.lang.String[] echo_wstring_s(java.lang.String[] arg) {
		return arg;
	}

	public LongBox echo_longBox(LongBox val) {
		return val;
	}

	public int[] echo_longBoxSeq(int[] val) {
		return val;
	}

	public java.io.Serializable get_value(int type) {
		switch(type) {
		case 0:
			return get_value_a(0);
		case 1:
			return get_value_b();
		case 2:
			return get_value_c();
		case 3:
			return get_value_d();
		case 4:
			return get_value_e();
		case 5:
			return get_value_f();
		case 6:
			return get_value_g();
		default:
			return null;
		}
	}

	public ValueA get_value_a(int type) {
		switch(type) {
		case 0:
			ValueA ret = new ValueAImpl();
			ret.l = 1;
			ret.str = "ValueA";
			return ret;
		case 2:
			return get_value_c();
		case 3:
			return get_value_d();
		default:
			return null;
		}
	}

	public ValueB get_value_b() {
		org.omg.CORBA_2_3.ORB orb = (org.omg.CORBA_2_3.ORB)_orb;			
		orb.register_value_factory(ValueBHelper.id(), new ValueBDefaultFactory());
		ValueBValueFactory factory = (ValueBValueFactory)orb.lookup_value_factory(ValueBHelper.id());

		ValueB ret = factory.init(1);
		ret.str = "ValueB";
		return ret;
	}

	public ValueC get_value_c() {
		ValueC ret = new ValueCImpl();
		ret.l = 1;
		ret.n = 0;
		ret.str = "ValueC";
		return ret;
	}

	public ValueD get_value_d() {
		ValueD ret = new ValueDImpl();
		ret.l = 1;
		ret.n = 0;
		ret.str = "ValueD";
		return ret;
	}

	public ValueERemote get_value_e_remote() {
		return (new ValueERemotePOATie(get_value_e(), _poa))._this(_orb);
	}

	public ValueE get_value_e() {
		ValueE ret = new ValueEImpl("remote");
		ret.prefix = "ValueE";
		return ret;
	}

	public ValueF get_value_f() {
		ValueF ret = new ValueFImpl();
		ret.l = F_L;
		return ret;
	}

	public ValueG get_value_g() {
		ValueG root = new ValueGImpl();
		root.idx = 0;
		root.name = "root";
		root.left = new ValueGImpl();
		root.left.idx = 1;
		root.left.name = "left";
		root.left.parent = root;
		root.right = new ValueGImpl();
		root.right.idx = 1;
		root.right.name = "right";
		root.right.parent = root;
		return root;
	}

	public Object get_abstract(int type) {
		if(type < 7)
			return get_value(type);
		return get_abstract_a(type-7);
	}			

	public AbstractA get_abstract_a(int type) {
		AbstractA ret;
		switch(type) {
		case 0:
			return (new AbstractA1Impl(_poa))._this(_orb);
		case 1:
			return new AbstractA2Impl();
		case 2:
			return new AbstractA3Impl("remote");
		case 3:
			return (new AbstractA1POATie(new AbstractA3Impl("remote"), _poa))._this(_orb);
		default:
			return null;
		}
	}	
}
